<?php
ini_set('display_errors', 1);
error_reporting(E_ALL);
session_start();


// Verifica si el usuario está logueado por sesión
if (isset($_SESSION['google_user']) || isset($_SESSION['microsoft_user'])) {
    // Si ya está logueado (Google o Microsoft), redirige a csv_upload.php
    header('Location: csv_upload.php');
    exit();
}

// Verificar si el usuario ha iniciado sesión con Microsoft (esto debe ocurrir después de la autenticación de Microsoft)
if (isset($_GET['code'])) {
    $code = $_GET['code'];

    // Intercambiar el código por un token de acceso
    require 'microsoft_config.php';
    $tokenUrl = 'https://login.microsoftonline.com/common/oauth2/v2.0/token';

    $data = [
        'client_id' => MICROSOFT_CLIENT_ID,
        'client_secret' => MICROSOFT_CLIENT_SECRET,
        'code' => $code,
        'redirect_uri' => MICROSOFT_REDIRECT_URI,
        'grant_type' => 'authorization_code'
    ];

    // Realizar el POST para obtener el token de acceso
    $ch = curl_init($tokenUrl);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_POST, true);
    curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($data));
    $response = curl_exec($ch);
    curl_close($ch);

    $responseData = json_decode($response, true);

    if (isset($responseData['access_token'])) {
        // Obtener información del usuario con el token
        $userInfoUrl = 'https://graph.microsoft.com/v1.0/me';
        $ch = curl_init($userInfoUrl);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_HTTPHEADER, [
            'Authorization: Bearer ' . $responseData['access_token']
        ]);
        $userInfo = curl_exec($ch);
        curl_close($ch);

        $userInfo = json_decode($userInfo, true);

        // Guardar los datos del usuario en la sesión
        $_SESSION['microsoft_user'] = $userInfo['mail'] ?? $userInfo['userPrincipalName']; // Puedes usar el correo o cualquier campo
        header('Location: csv_upload.php'); // Redirige a csv_upload.php
        exit();
    } else {
        $error = 'No se pudo autenticar con Microsoft.';
    }
}

// URLs de autenticación con Google y Microsoft
$googleAuthUrl = "https://accounts.google.com/o/oauth2/auth?client_id=YOUR_GOOGLE_CLIENT_ID&redirect_uri=YOUR_REDIRECT_URI&scope=email profile&response_type=code";

require 'microsoft_config.php';
$microsoftAuthUrl = "https://login.microsoftonline.com/common/oauth2/v2.0/authorize?client_id=" . MICROSOFT_CLIENT_ID
    . "&response_type=code"
    . "&redirect_uri=" . MICROSOFT_REDIRECT_URI
    . "&scope=openid email profile";
?>

<!DOCTYPE html>
<html lang="es">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Iniciar Sesión</title>
</head>
<body>
    <h2>Iniciar Sesión</h2>
    
    <!-- Mostrar mensaje de error si hay problemas con la autenticación -->
    <?php if (isset($error)) echo "<p style='color: red;'>$error</p>"; ?>

    <!-- Enlaces para iniciar sesión con Google y Microsoft -->
    <a href="<?= $googleAuthUrl ?>">Iniciar sesión con Google</a>
    <br>
    <a href="<?= $microsoftAuthUrl ?>">Iniciar sesión con Microsoft</a>

</body>
</html>
