<?php
ini_set('display_errors', 1);
error_reporting(E_ALL);

session_start();
require 'microsoft_config.php'; // Archivo con la configuración (credenciales de Microsoft)

if (!isset($_GET['code'])) {
    die("Error: No se recibió el código de autorización.");
}

// Verificar si se recibe el código de autorización (Esto lo puedes almacenar en una sesión o mostrar después de la redirección)
$_SESSION['auth_code'] = $_GET['code']; // Guardar el código para usarlo más tarde si es necesario.

// Datos de autenticación
$tokenUrl = "https://login.microsoftonline.com/common/oauth2/v2.0/token";
$redirectUri = MICROSOFT_REDIRECT_URI;

// Configuración de la solicitud para obtener el token de acceso
$data = [
    "client_id" => MICROSOFT_CLIENT_ID,
    "client_secret" => MICROSOFT_CLIENT_SECRET,
    "code" => $_GET['code'],
    "redirect_uri" => $redirectUri,
    "grant_type" => "authorization_code",
    "scope" => "https://graph.microsoft.com/.default"
];

// Enviar la solicitud para obtener el token
$ch = curl_init($tokenUrl);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_POST, true);
curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($data));
curl_setopt($ch, CURLOPT_HTTPHEADER, ["Content-Type: application/x-www-form-urlencoded"]);

$response = curl_exec($ch);
curl_close($ch);

if ($response === false) {
    die("Error al realizar la solicitud cURL para obtener el token.");
}

$tokenData = json_decode($response, true);

// Verifica si se obtuvo el token correctamente
if (!isset($tokenData['access_token'])) {
    echo "<p>Error al obtener el token de acceso: </p>";
    echo "<pre>" . print_r($tokenData, true) . "</pre>";
    die();  // Mostrar los detalles del error y detener el script.
}

// Después de obtener el token de acceso...
$accessToken = $tokenData['access_token'];

// Guarda el token de acceso en la sesión
$_SESSION['microsoft_access_token'] = $accessToken;

// Evita cualquier salida aquí antes de la redirección.
// Muestra el mensaje de éxito y redirige
$_SESSION['success_message'] = "Token de acceso obtenido correctamente. Serás redirigido a la página de carga de CSV en 5 segundos.";

header("Refresh: 5; url=onedrive.iqvia.php");
exit();  // Detiene la ejecución del script.
?>